
extern int length = 100;   // The amount of bars sent to be processed
string nameData,symbol;
extern string symbols = "EURUSD,GBPUSD,USDJPY";
extern string timeframe = "1,15,60,240,1440";
int TF;

int start()
{
   int sym_count = count(symbols,",");
   int per_count = count(timeframe,",");
   string symb_array[];
   string timeframe_array[];
   ArrayResize(symb_array,sym_count);
   ArrayResize(timeframe_array,per_count);
   split(symbols,symb_array);
   split(timeframe,timeframe_array);
   int old_bars;   // remember the amount of bars already known   
   while(!IsStopped())
   {   
   for(int i=0;i<sym_count;i++)
   {
   for(int j=0;j<per_count;j++)
   {
   nameData = symb_array[i]+timeframe_array[j]+".csv";         // name of the data file to be sent
   symbol = symb_array[i];
   TF = StrToInteger(timeframe_array[j]);
   if(iBars(symb_array[i],StrToInteger(timeframe_array[j]))==0)continue;
   if(!GlobalVariableCheck(symb_array[i]+timeframe_array[j]+"bars"))GlobalVariableSet(symb_array[i]+timeframe_array[j]+"bars",0);
   if (GlobalVariableGet(symb_array[i]+timeframe_array[j]+"bars") != iBars(symb_array[i],StrToInteger(timeframe_array[j]))-1)      // if a new bar is received 
   {
         
        int handle = FileOpen(nameData, FILE_CSV|FILE_READ,';');
        if(handle<0)createFile();else{
         FileClose(handle);
         
        handle = FileOpen(nameData, FILE_CSV|FILE_READ|FILE_WRITE,';');
        int count=0;
        while(!FileIsEnding(handle)){
        FileReadString(handle);
        if(FileIsLineEnding(handle))count++;
        }
        
        FileSeek(handle,0,SEEK_SET);
        int recount = 0;
        while(!FileIsEnding(handle)){
        FileReadString(handle);
        if(FileIsLineEnding(handle)){
        recount++;
        if(recount==count-2){
        FileSeek(handle,0,SEEK_END);
        if(StrToTime(FileReadString(handle)+FileReadString(handle))!=iTime(symbol,TF,1))FileWrite(handle, TimeToStr(iTime(symbol,TF,1), TIME_DATE), TimeToStr(iTime(symbol,TF,1), TIME_SECONDS), iHigh(symbol,TF,1), iLow(symbol,TF,1), iClose(symbol,TF,1), iOpen(symbol,TF,1), iVolume(symbol,TF,1));
        break;
        }}
        }
        FileClose(handle);                            
        
        }
      }                              
      GlobalVariableSet(symb_array[i]+timeframe_array[j]+"bars",iBars(symb_array[i],StrToInteger(timeframe_array[j]))-1);              // remember how many bars are known      
   }}      
   
   Sleep(30000);
   }
   return(0);
}

void createFile()
{

    int handle = FileOpen(nameData, FILE_CSV|FILE_WRITE,';');
        if(handle < 1)
        {
          Comment("Creation of "+nameData+" failed. Error #", GetLastError());
          return(0);
        }
        FileWrite(handle, ServerAddress(), symbol, TF);                  // heading
        FileWrite(handle, "DATE","TIME","HIGH","LOW","CLOSE","OPEN","VOLUME");   // heading
        int i;
        for (i=length-1; i>=0; i--)
        {
          FileWrite(handle, TimeToStr(iTime(symbol,TF,i), TIME_DATE), TimeToStr(iTime(symbol,TF,i), TIME_SECONDS),
                            iHigh(symbol,TF,i), iLow(symbol,TF,i), iClose(symbol,TF,i), iOpen(symbol,TF,i), iVolume(symbol,TF,i));
        }
        FileClose(handle);
        Print("File "+nameData+" has been created. "+TimeToStr(TimeCurrent(), TIME_SECONDS) );
}

int count(string str, string delimiter)
{
  int i = 0;
  int pos = StringFind(str, delimiter);
while(pos != -1)
   {
      i++;
      str = StringSubstr(str, pos+StringLen(delimiter));
      pos = StringFind(str, delimiter);
      if(pos == -1) break;
   }
   return(i+1);
}

int split(string str, string& arr[], string delimiter=",")
{
   int i = 0;
   int pos = StringFind(str, delimiter);
   while(pos != -1)
   {
   arr[i] = StringSubstr(str, 0, pos);
      i++;
      str = StringSubstr(str, pos+StringLen(delimiter));
      
      pos = StringFind(str, delimiter);
      if(pos == -1 || str == "") break;
   }
   arr[i] = str;
   return(0);
}